#
# photodiode.py
#
# visualize values from phototransistor using graphis
# the intensity of light change the color of the graphics
#

from Tkinter import *
import serial
import math
WINDOW = 800 # window size
eps = 0.5 # filter time constant
filter = 0.0 # filtered value

def idle(parent,canvas):
   global filter, eps
   #
   # idle routine
   #
   byte2 = 0
   byte3 = 0
   byte4 = 0
   ser.flush()
  

   for i in range(1,2000): 

      while 1:
      #
      # find framing 
      #
        byte1 = byte2
        byte2 = byte3
        byte3 = byte4
        byte4 = ord(ser.read())
        if ((byte1 == 1) & (byte2 == 2) & (byte3 == 3) & (byte4 == 4)):
          break
      low = ord(ser.read())
      high = ord(ser.read())
      value = 256*high + low
      filter = ((1-eps)*filter + eps*value)
      x = int(.2*WINDOW + (.9-.2)*WINDOW*filter/1024.0)
      canvas.itemconfigure("text",text="%.1f"%value)
      alpha_0 += 0.003
      alpha_1 += 0.018
      alpha_2 -= 0.054
      alpha_3 -= 0.108
      alpha_4 += 0.018

  

      color= 'red'
      
      if(value>400):
        color= 'green'
      
      if(value>800):
        color='blue'

#
#  check command line arguments
#
if (len(sys.argv) != 2):
   print "command line: hello.light.45.py serial_port"
   sys.exit()
port = sys.argv[1]
#
# open serial port
#
ser = serial.Serial(port,9600)
ser.setDTR()
#
# set up GUI
#
root = Tk()
root.title('dfb sensor')
canvas = Canvas(root, width=WINDOW, height=WINDOW, background='white')
canvas.create_text(.1*WINDOW,.125*WINDOW,text="%.1f"%value,font=("Helvetica", 24),tags="text",fill="#0000b0")
canvas.pack()
#
# start idle loop
#
root.after(100,idle,root,canvas) #loop
root.mainloop()